import React from 'react';
import { Icon, Form, Button, Input, Spin, Table, message, Select, Modal, InputNumber, Upload } from 'antd';
import './techProduct.less';
import { getConversionForm, beforeUploadFile, newDownloadFile } from '../../tools.js';
import { conversionFormList, technicalSourceList } from '../../dataDic.js';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';

const AchievementDescFrom = Form.create()(React.createClass({
    getInitialState() {
        return {
            loading: false,
            yearOption: [],
            conversionFormOption: [],
            technicalSourceOption: []
        };
    },
    componentWillMount() {
        let d = new Date();
        let _me = this;
        d = d.getFullYear();
        for (let i = d; i > d - 20; i--) {
            _me.state.yearOption.push(
                <Select.Option key={i.toString()} >{i}</Select.Option>
            )
        };
        conversionFormList.map(function (item) {
            _me.state.conversionFormOption.push(
                <Select.Option value={item.value} key={item.key}>{item.key}</Select.Option>
            )
        });
        technicalSourceList.map(function (item) {
            _me.state.technicalSourceOption.push(
                <Select.Option value={item.key} key={item.key}>{item.key}</Select.Option>
            )
        });
        if (this.props.activityNumberList && this.props.activityNumberList.length) {
            for (let i = 0; i < this.props.activityNumberList.length; i++) {
                _me.state.technicalSourceOption.push(
                    <Select.Option value={this.props.activityNumberList[i].activityNumber}
                        key={this.props.activityNumberList[i].uid}>
                        {this.props.activityNumberList[i].activityName}-{this.props.activityNumberList[i].activityNumber}
                    </Select.Option>
                )
            };
        };
    },
    handleSubmit(e) {
        e.preventDefault();
        if (!this.state.year && !this.props.data.year) {
            message.warning("请选择一个年份！")
            return;
        };
        this.props.form.validateFields((err, values) => {
            if (!err) {
                this.props.spinState(true);
                $.ajax({
                    method: "POST",
                    dataType: "json",
                    crossDomain: false,
                    url: globalConfig.context + "/api/user/cognizance/disposeAchievement",
                    data: {
                        id: this.props.data.id,
                        achievementName: values.achievementName,
                        source: values.source,
                        conversionForm: values.conversionForm,
                        conversionResult: values.conversionResult,
                        year: this.state.year || this.props.data.year,
                        enclosureUrl: this.state.enclosureUrl
                    }
                }).done(function (data) {
                    if (!data.error.length) {
                        message.success('保存成功！');
                        this.props.clickOk();
                        this.props.spinState(false);
                        this.props.form.resetFields();
                    } else {
                        message.warning(data.error[0].message);
                        this.props.spinState(false);
                    }
                }.bind(this));
            }
        });
    },
    componentWillReceiveProps(nextProps) {
        if (!this.props.visible && nextProps.visible) {
            this.props.form.resetFields();
            this.state.fileList = [];
            this.state.enclosureUrl = null;
        };
    },
    render() {
        const FormItem = Form.Item;
        const { getFieldDecorator } = this.props.form;
        const theData = this.props.data;
        const formItemLayout = {
            labelCol: { span: 4 },
            wrapperCol: { span: 16 },
        };
        const _me = this;
        return (
            <Form onSubmit={this.handleSubmit} className="activityCost-form">
                <div className="activityCost-title"><span>年份: </span>
                    {
                        theData.year ? <span>{theData.year}</span> :
                            <Select placeholder="请选择年份" style={{ width: 200 }}
                                onSelect={(e, n) => { this.state.year = e }}>
                                {this.state.yearOption}
                            </Select>
                    }
                </div>
                <div className="clearfix">
                    <FormItem
                        {...formItemLayout}
                        label="成果名称"
                    >
                        {getFieldDecorator('achievementName', {
                            rules: [{ type: 'string', required: true, message: '此项为必填项!' }],
                            initialValue: theData.achievementName
                        })(
                            <Input />
                            )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label="成果来源"
                    >
                        {getFieldDecorator('source', {
                            rules: [{ type: 'string', required: true, message: '此项为必填项!' }],
                            initialValue: theData.source
                        })(
                            <Select placeholder="请选择成果来源" style={{ width: 200 }}>
                                {this.state.technicalSourceOption}
                            </Select>
                            )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label="转化形式"
                    >
                        {getFieldDecorator('conversionForm', {
                            rules: [{ type: 'string', required: true, message: '此项为必填项!' }],
                            initialValue: theData.conversionForm
                        })(
                            <Select placeholder="请选择转化形式" style={{ width: 200 }}>
                                {this.state.conversionFormOption}
                            </Select>
                            )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label="转化结果"
                    >
                        {getFieldDecorator('conversionResult', {
                            rules: [{ type: 'string', required: true, message: '此项为必填项!' }],
                            initialValue: theData.conversionResult
                        })(
                            <Input type="textarea" rows={6} />
                            )}
                    </FormItem>
                </div>
                <div className="hrSituation-roster">
                    <Upload
                        name="ratepay"
                        action={globalConfig.context + "/api/user/cognizance/uploadAchievement"}
                        data={{ 'sign': 'achievement' }}
                        beforeUpload={beforeUploadFile}
                        fileList={this.state.fileList}
                        onChange={(info) => {
                            if (info.file.status !== 'uploading') {
                                console.log(info.file, info.fileList);
                            }
                            if (info.file.status === 'done') {
                                if (!info.file.response.error.length) {
                                    message.success(`${info.file.name} 文件上传成功！`);
                                } else {
                                    message.warning(info.file.response.error[0].message);
                                    return;
                                };
                                this.state.enclosureUrl = info.file.response.data;
                            } else if (info.file.status === 'error') {
                                message.error(`${info.file.name} 文件上传失败。`);
                            };
                            this.setState({ fileList: info.fileList.slice(-1) });
                        }}
                    >
                        <Button><Icon type="upload" /> 上传科技成果附件 </Button>
                    </Upload>
                    <p style={{ marginTop: '10px' }}>{theData.enclosureUrl ? <a onClick={newDownloadFile.bind(null, theData.id, 'achievement', '/api/user/cognizance/downloadAchievement')}>{theData.enclosureDownloadFileName}</a> : <span><Icon type="exclamation-circle" style={{ color: '#ffbf00', marginRight: '6px' }} />未上传！</span>}</p>
                </div>
                <FormItem style={{ marginTop: '20px' }}>
                    <Button className="set-submit" type="primary" htmlType="submit">保存</Button>
                    <Button type="ghost" style={{ marginLeft: '20px' }} onClick={this.props.closeModal}>取消</Button>
                </FormItem>
            </Form >
        );
    },
}));

const AchievementDesc = React.createClass({
    getInitialState() {
        return {
            visible: false,
            loading: false
        };
    },
    componentWillReceiveProps(nextProps) {
        this.state.visible = nextProps.showDesc
    },
    showModal() {
        this.setState({
            visible: true,
        });
    },
    handleOk() {
        this.setState({
            visible: false,
        });
        this.props.closeDesc(false, true);
    },
    handleCancel(e) {
        this.setState({
            visible: false,
        });
        this.props.closeDesc(false);
    },
    spinChange(e) {
        this.setState({
            loading: e
        });
    },
    render() {
        return (
            <div className="patent-addNew">
                <Modal maskClosable={false} title="科技成果转化" visible={this.state.visible}
                    onOk={this.handleOk} onCancel={this.handleCancel}
                    width='800px'
                    footer='' >
                    <Spin spinning={this.state.loading} className='spin-box'>
                        <AchievementDescFrom
                            data={this.props.data}
                            visible={this.state.visible}
                            activityNumberList={this.props.activityNumberList}
                            spinState={this.spinChange} closeModal={this.handleCancel} clickOk={this.handleOk} />
                    </Spin>
                </Modal>
            </div>
        );
    },
});

const Achievement = React.createClass({
    loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.when($.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/user/cognizance/achievementList",
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
            }
        }), $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/user/cognizance/activityNumber",
        })).done((data1, data2) => {
            let data = data1[0];
            let activityNumber = data2[0];
            if (!data.data || !data.data.list) {
                if (data.error && data.error.length) {
                    message.warning(data.error[0].message);
                    this.state.ButtonDisabled = true;
                };
                return;
            };
            if (!activityNumber.data) {
                if (activityNumber.error && activityNumber.error.length) {
                    message.warning(activityNumber.error[0].message);
                    this.state.ButtonDisabled = true;
                };
                return;
            };
            for (let i = 0; i < data.data.list.length; i++) {
                let thisdata = data.data.list[i];
                this.state.data.push({
                    key: i,
                    id: thisdata.id,
                    uid: thisdata.uid,
                    achievementName: thisdata.achievementName,
                    source: thisdata.source,
                    conversionForm: thisdata.conversionForm,
                    conversionResult: thisdata.conversionResult,
                    year: thisdata.year,
                    enclosureUrl: thisdata.enclosureUrl,
                    enclosureDownloadFileName: thisdata.enclosureDownloadFileName,
                    enclosure: [thisdata.id, thisdata.enclosureDownloadFileName]
                });
            };
            this.state.activityNumberList = activityNumber.data;
            this.state.pagination.current = data.data.pageNo;
            this.state.pagination.total = data.data.totalCount;
            this.setState({
                dataSource: this.state.data,
                pagination: this.state.pagination
            });
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            selectedRowKeys: [],
            selectedRows: [],
            loading: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '年份',
                    dataIndex: 'year',
                    key: 'year'
                }, {
                    title: '成果名称',
                    dataIndex: 'achievementName',
                    key: 'achievementName'
                }, {
                    title: '成果来源',
                    dataIndex: 'source',
                    key: 'source',
                }, {
                    title: '转化形式',
                    dataIndex: 'conversionForm',
                    key: 'conversionForm',
                    render: (text) => { return getConversionForm(text) }
                }, {
                    title: '转化结果',
                    dataIndex: 'conversionResult',
                    key: 'conversionResult',
                }, {
                    title: '相关附件',
                    dataIndex: 'enclosure',
                    key: 'enclosure',
                    render: (text) => {
                        return <a onClick={newDownloadFile.bind(null, text[0], 'achievement', '/api/user/cognizance/downloadAchievement')}>{text[1]}</a>
                    }
                }
            ],
            dataSource: []
        };
    },
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
        this.state.RowData = record;
        this.setState({
            showDesc: true
        });
    },
    delectRow() {
        let deletedIds = [];
        for (let idx = 0; idx < this.state.selectedRows.length; idx++) {
            let rowItem = this.state.selectedRows[idx];
            if (rowItem.id) {
                deletedIds.push(rowItem.id)
            }
        }
        this.setState({
            selectedRowKeys: [],
            loading: deletedIds.length > 0
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/user/cognizance/deleteAchievement",
            data: {
                ids: deletedIds
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('删除成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    closeDesc(e, s) {
        this.state.showDesc = e;
        if (s) {
            this.loadData();
        };
    },
    search() {
        this.loadData();
    },
    reset() {
        this.loadData();
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRows: selectedRows,
                    selectedRowKeys: selectedRowKeys
                });
            }
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        return (
            <div className="user-content" >
                <div className="content-title">
                    <span>科技成果转化</span>
                </div>
                <div className="user-search">
                    <p>
                        <Button style={{ background: "#ea0862", border: "none", color: "#fff" }}
                            disabled={this.state.ButtonDisabled}
                            onClick={this.tableRowClick}>添加<Icon type="plus" /></Button>
                        <Button style={{ background: "#3fcf9e", border: "none", color: "#fff" }}
                            disabled={!hasSelected}
                            onClick={this.delectRow}>删除<Icon type="minus" /></Button>
                    </p>
                </div>
                <div className="patent-table">
                    <Spin spinning={this.state.loading}>
                        <Table columns={this.state.columns}
                            dataSource={this.state.dataSource}
                            pagination={this.state.pagination}
                            rowSelection={rowSelection}
                            onRowClick={this.tableRowClick} />
                    </Spin>
                </div>
                <AchievementDesc
                    data={this.state.RowData}
                    activityNumberList={this.state.activityNumberList}
                    showDesc={this.state.showDesc} closeDesc={this.closeDesc} />
            </div >
        );
    }
});

export default Achievement;